<script setup lang="ts">
    import { onBeforeMount, ref, watch } from 'vue'
    import { DashboardApi } from '@/elusServiceOffer/entities/dashboard/DashboardApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { serviceOfferIdInjectionKey } from '@/shared/constants'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import SNavigationTabsExtension from '@/elusServiceOffer/components/layout/SNavigationTabsExtension.vue'
    import { useRouter } from 'vue-router'
    import { ServiceOfferNamespaces } from '@/serviceOffer/entities/serviceOffer/ServiceOffer'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import { requiredInject } from '@/shared/helpers/types'

    const msal = useMsal()

    const router = useRouter()
    const userStore = useUserStore(msal)

    const elusServiceOfferTitle = router.currentRoute.value.matched.find(
        (record) => record.name === 'elus-service-offer-root'
    )?.meta.title

    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)

    const dashboardApi = new DashboardApi(msal)

    const dashboardUrl = ref('')

    const metabaseIframe = ref<HTMLIFrameElement | undefined>(undefined)

    onBeforeMount(() => {
        const iframeResizerScript = document.createElement('script')
        iframeResizerScript.setAttribute(
            'src',
            import.meta.env.VITE_METABASE_IFRAME_RESIZER_SCRIPT
        )
        iframeResizerScript.onload = () => {
            metabaseIframe.value?.setAttribute(
                'onload',
                'iFrameResize({}, this)'
            )
        }
        document.head.appendChild(iframeResizerScript)

        watch(
            [() => msal.accounts, () => userStore.isImpersonating],
            () => {
                dashboardApi.get(serviceOfferId.value, 1).then((dashboard) => {
                    dashboardUrl.value = dashboard.url
                })
            },
            { immediate: true }
        )
    })
</script>

<template>
    <s-contextual-navbar :page-title="elusServiceOfferTitle as string">
        <template v-if="$vuetify.display.smAndUp" #extension>
            <s-navigation-tabs-extension></s-navigation-tabs-extension>
        </template>
        <template #contextualButtons>
            <v-btn
                v-if="
                    userStore.currentUser.reachableRoles.includes(
                        `SERVICEOFFER_${serviceOfferId}_ROLE_SERVICEOFFER_ADMIN_LIST_USERS`
                    )
                "
                data-cy="btn-interventions-admin-user-list"
                icon="mdi-cog-outline"
                color="on-background"
                :to="{
                    name: 'ElusServiceOffer/administration/utilisateurs/liste',
                    params: {
                        serviceOfferId,
                        serviceOfferType:
                            ServiceOfferNamespaces.InterventionServiceOffer,
                    },
                }"
            ></v-btn>
        </template>
    </s-contextual-navbar>
    <!-- <s-bottom-navigation v-if="$vuetify.display.xs"></s-bottom-navigation> -->
    <v-main>
        <iframe
            ref="metabaseIframe"
            class="metabase-dashboard"
            :src="dashboardUrl"
            title="Tableau de bord Metabase"
        ></iframe>
    </v-main>
</template>

<style scoped lang="scss">
    .metabase-dashboard {
        border: 0;
        width: 100%;
    }
</style>
